# Modify only the argument marked as 'modify me.'

import os
import glob
import numpy as np

###fix###
no_rewind = True
lrr=True
pr = 80
###fix###


##########
do_warmup=True
do_lrr=True
do_pretrained=True
##########

##### modify me, set your gpu to use
gpu = 0
##### modify me

##### modify me, set the model to use
#arch = 'resnet50'
arch = 'mobilenetv2'
#arch = 'shufflenet'
#arch = 'efficientnet'
##### modify me

dataset='cifar100'


##### modify me, determine whether to use AWS or LRR
aws = False # False: LRR, True: AWS
##### modify me

pr = 80
seed=1

warm_up=10
final_epochs=100
epochs=10

imp_iters=15

################warmup#####################
run = f'python main.py --gpu-id {gpu} --imp_iters 0 --epochs {warm_up} --manualSeed {seed} --warm_up {warm_up}'

run += f' --arch {arch}'

name = f'{dataset}_{arch}_warmup{warm_up}_seed{seed}'

run += f' --dataset {dataset}'

if aws:
    run += ' --aws'
    name += '_aws'

run += f' --name {name}'

if do_warmup:
    os.system(run)
################warmup#####################


################lrr or aws#####################
run = f'python main.py --gpu-id {gpu} --pruning_ratio {pr} --imp_iters {imp_iters} --epochs {epochs} --manualSeed {seed} --warm_up {warm_up}'

run += ' --no_rewind'
name = f'lrr_warm{warm_up}_iters{imp_iters}_epochs{epochs}_pr{pr}_seed{seed}'

name += f'_{arch}'
run += f' --arch {arch}'

name += f'_{dataset}'
run += f' --dataset {dataset}'

if aws:
    run += ' --aws'
    name += '_aws'

run += f' --name {name}'

if do_lrr:
    os.system(run)
################lrr or aws#####################


################final_training#####################
add = ''
if aws:
    add += '_aws'

pretraineds = glob.glob(f'checkpoint/lrr_warm{warm_up}_iters{imp_iters}_epochs{epochs}_pr{pr}_seed{seed}_{arch}_{dataset}{add}/checkpoint_imp*')
pretraineds.sort()

print(len(pretraineds))
prs = []
for num, pretrained in enumerate(pretraineds):
    pos1 = pretrained.find('pr0')
    pos2 = pretrained.find('_final')
    pr = round(float(pretrained[pos1+2:pos2]),3)
    prs.append(pr)

prs = np.array(prs)
idxes = np.argsort(prs)

pretraineds = np.array(pretraineds)[idxes].tolist()

for num, pretrained in enumerate(reversed(pretraineds)):
    print(f'-----{num}/{len(pretraineds)}-----')
    pos1 = pretrained.find('pr0')
    pos2 = pretrained.find('_final')
    pr = str(round(float(pretrained[pos1+2:pos2]),3))

    for sign_transfer in [True, False]: # False: LRR or AWS solution, True: sign transfer to random init
        name = f'lrrpretrained_warm{warm_up}_iters{imp_iters}_epochs{epochs}_pr{pr}_seed{seed}_{arch}_{dataset}'

        run = f'python main.py --gpu-id {gpu} --imp_iters 0 --epochs {final_epochs} --manualSeed {seed} --warm_up {warm_up} --pretrained {pretrained} --lr_schedule'
        run += f' --arch {arch}'
        run += f' --dataset {dataset}'

        if sign_transfer:
            name += '_signtransfer'
            run += ' --sign_transfer'
        
        if aws:
            name += '_aws'
        
        run += f' --name {name}'

        if do_pretrained:
            os.system(run)